/****************************************************************
File generated by Device Model Compiler: BMAC
Author: Bo Wan, 2003
Copyright 2003(c) Mixed-Signal CAD lab. University of Washington.
All rights reserved.
****************************************************************/

#include "spice.h"
#include <stdio.h>
#include "util.h"
#include "smpdefs.h"
#include "cktdefs.h"

// Needed #includes
#include "setup_gen1.gh"

#include "sperror.h"
#include "suffix.h"

#include "genCommon.h"
extern void loadTables();

/* macro to make elements with built in test for out of memory */
#define TSTALLOC(ptr,first,second) \
if((here->ptr = SMPmakeElt(matrix,here->first,here->second))==(double *)NULL) \
{ \
	return(E_NOMEM); \
}

/**************************************************************
load the device structure with those pointers needed later 
for fast matrix loading 
**************************************************************/
int BMACRESsetup(matrix,inModel,ckt,states)
	register SMPmatrix *matrix;
	GENmodel *inModel;
	CKTcircuit*ckt;
	int *states;
{
	register BMACRESmodel *model = (BMACRESmodel *)inModel;
	register BMACRESinstance *here;
	int 	 error;
	CKTnode* tmpNode;

#ifdef TableLookup
	loadTables();
	// ???? when to freeTables() ????
#endif
	fprintf(stderr,"\tUsing new model for: %s\n",model->BMACRESmodName);

	/*  loop through all the device models */
	for( ; model != NULL; model = model->BMACRESnextModel )
	{

// initialize/assign model parameters with default value if any
#include "setup_gen2.gc"

		/* loop through all the instances of the model */
		for (here = model->BMACRESinstances; here != NULL ;
			here=here->BMACRESnextInstance)
		{

// 1) initialize/assign instance parameters with default value if any
// 2) allocate space for jacobian matrix
//#include "setup_gen3.gc"
#include "new_setup_gen3.gc"

        	}
	}

	return(OK);
}
