/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1987 Thomas L. Quarles
**********/

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "devdefs.h"
#include "ifsim.h"
#include "opampdefs.h"
#include "sperror.h"
#include "util.h"
#include "suffix.h"

/* ARGSUSED */
int
OPAMPask(ckt,inst,which,value,select)
    CKTcircuit *ckt;
    GENinstance *inst;
    int which;
    IFvalue *value;
    IFvalue *select;
{
    OPAMPinstance *here = (OPAMPinstance *)inst;

    switch(which) {
        case OPAMP_CCOMP:
            value->iValue = here->OPAMPCcomp;
            return (OK);
        case OPAMP_SRP:
            value->iValue = here->OPAMPSRp;
            return (OK);
        case OPAMP_SRM:
            value->iValue = here->OPAMPSRm;
            return (OK);
        case OPAMP_IOUTP:
            value->iValue = here->OPAMPIoutp;
            return (OK);
        case OPAMP_IOUTM:
            value->rValue = here->OPAMPIoutm;
            return (OK);
        case OPAMP_AV0:
            value->rValue = here->OPAMPAv0;
            return (OK);
        case OPAMP_VT:
            value->rValue = here->OPAMPVt;
            return (OK);
        case OPAMP_ROUT:
            value->iValue = here->OPAMPRout;
            return (OK);
        case OPAMP_VOUTM:
            value->iValue = here->OPAMPVoutm;
            return (OK);
        case OPAMP_VOUTP:
            value->iValue = here->OPAMPVoutp;
            return (OK);
        case OPAMP_CMRR:
            value->iValue = here->OPAMPCMRR;
            return (OK);
        case OPAMP_VOS:
            value->iValue = here->OPAMPVos;
            return (OK);
        default:
            return (E_BADPARM);
    }
    /* NOTREACHED */
}
