/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1985 Thomas L. Quarles
**********/
/*
 */

#include "spice.h"
#include <stdio.h>
#include "util.h"
#include "ifsim.h"
#include "opampdefs.h"
#include "sperror.h"
#include "suffix.h"


/* ARGSUSED */
int
OPAMPparam(param,value,inst,select)
    int param;
    IFvalue *value;
    GENinstance *inst;
    IFvalue *select;
{
    OPAMPinstance *here = (OPAMPinstance *)inst;
    switch(param) {
        case OPAMP_CCOMP:
	    here->OPAMPCcomp = value->rValue;
            here->OPAMPCcompGiven = TRUE;
            return (OK);
        case OPAMP_SRP:
	    here->OPAMPSRp = value->rValue;
            here->OPAMPSRpGiven = TRUE;
            return (OK);
        case OPAMP_SRM:
	    here->OPAMPSRm = value->rValue;
            here->OPAMPSRmGiven = TRUE;
            return (OK);
        case OPAMP_IOUTP:
	    here->OPAMPIoutp = value->rValue;
            here->OPAMPIoutpGiven = TRUE;
            return (OK);
        case OPAMP_IOUTM:
	    here->OPAMPIoutm = value->rValue;
            here->OPAMPIoutmGiven = TRUE;
            return (OK);
        case OPAMP_AV0:
	    here->OPAMPAv0 = value->rValue;
            here->OPAMPAv0Given = TRUE;
            return (OK);
        case OPAMP_VT:
	    here->OPAMPVt = value->rValue;
            here->OPAMPVtGiven = TRUE;
            return (OK);
        case OPAMP_ROUT:
	    here->OPAMPRout = value->rValue;
            here->OPAMPRoutGiven = TRUE;
            return (OK);
        case OPAMP_VOUTM:
	    here->OPAMPVoutm = value->rValue;
            here->OPAMPVoutmGiven = TRUE;
            return (OK);
        case OPAMP_VOUTP:
	    here->OPAMPVoutp = value->rValue;
            here->OPAMPVoutpGiven = TRUE;
            return (OK);
        case OPAMP_CMRR:
	    here->OPAMPCMRR = value->rValue;
            here->OPAMPCMRRGiven = TRUE;
            return (OK);
        case OPAMP_VOS:
	    here->OPAMPVos = value->rValue;
            here->OPAMPVosGiven = TRUE;
            return (OK);
        default:
            return(E_BADPARM);
    }
    /* NOTREACHED */
}
